#pragma rtGlobals=1		// Use modern global access method.

Menu "Particle Analysis"
"ROI tools", PA_ROI_tools()
"Single image", PA_singleImage()
"Image series", PA_imageSeries()
"Average island size", PA_DarkIslandSize()
end

Proc PA_ROI_tools()
	// recall data folder
	String dfStr=SIS_getDataFolderName()
	SetDataFolder root:$(dfStr):
	// recall ROI tools
	WMCreateImageROIPanel();
End

Function PA_singleImage()
	// datafolder
	String dfStr=SIS_getDataFolderName() // where image is stored
	SetDataFolder root:$(dfStr)
	String imageStr=SIS_getImageStackName() // image name
	String winStr=SIS_getWinName() // nome della finestra
	// global variables
	NVAR threshold = root:SIS:threshold	
	NVAR minimumarea = root:SIS:minimumarea
	NVAR thresholdmethod = root:SIS:thresholdmethod	
	NVAR objecttype = root:SIS:objecttype
	NVAR particlemode = root:SIS:particlemode	
	SetDataFolder root:SIS
	if (!NVAR_Exists(threshold))	     // No such global numeric variable?
		variable/G threshold = 128    // Create and initialize it
	endif
	if (!NVAR_Exists(minimumarea))	// No such global numeric variable?
		variable/G minimumarea = 6	// Create and initialize it
	endif
	if (!NVAR_Exists(thresholdmethod))	 // No such global numeric variable?
		variable/G thresholdmethod = 1	// Create and initialize it
	endif
	if (!NVAR_Exists(particlemode))	 // No such global numeric variable?
		variable/G particlemode = 1	// Create and initialize it
	endif
	if (!NVAR_Exists(objecttype))	     // No such global numeric variable?
		variable/G objecttype = 1	// Create and initialize it
	endif
	
	//input
	SetDataFolder root:$(dfStr)
	variable thresh=threshold
	variable minarea=minimumarea
	variable objtype=objecttype
	variable mode=particlemode
	variable thm=thresholdmethod+1
	
	String objtypeStr="dark regions"
	Prompt objtype,  "object type", popup "dark regions; bright regions;"
	Prompt mode, "user threshold mode", popup "user level (0-255);halfway within ROI; V_avg of ROI; halfway within histogram;"
	Prompt thresh, "threshold"
	Prompt thm, "threshold method:" popup "user level;iterative;histogram;adaptive thresholding;entropy corrected fuzzy thresholding;fuzzy thresholding 2;"
	Prompt minarea, "minimum area"
	doPrompt  "input particle analysis", objtype, mode, thresh, minarea, thm
	if (V_flag==0)
	
		minimumarea=minarea
		objecttype=objtype
		particlemode=mode
		thresholdmethod=thm-1
		
		if (exists("M_ROIMask")==1) // the ROI wave exists otherwise quit
			// bright or dark
			if (objtype ==2)
				objtypeStr="bright regions"
			endif
			// calc ROI area
			waveStats/Q M_ROIMask 
			variable areaTotROIMask=V_npnts-V_sum
			// calc threshold
			ImageTransform convert2gray $imageStr // creates binary image and store result in M_Image2grey
			if (mode > 1)
				ImageStats/R=M_ROIMask M_Image2Gray
				if (mode == 2)
					thresh = (V_max+V_min)/2
				endif
				if (mode == 3)
					thresh = V_rms
				endif
				if (mode == 4)
					variable midPos=(V_max+V_min)/2
					ImageHistogram/R=M_ROIMask M_Image2Gray
					Wavestats/R=(0,midpos)/Q W_ImageHist
					variable minThres=V_maxloc
					variable minVal=V_max
					//print minthres
					Wavestats/R=(midpos,255)/Q W_ImageHist
					variable maxThres=V_maxloc
					variable maxVal=V_max
					thresh = 0.5*(minThres+maxThres)
					//thresh = 0.5*(PA_histogramThreshold(W_ImageHist,0.01)+PA_histogramThreshold(W_ImageHist,0.99))
				endif
			endif
			if (objtype==1)
				ImageThreshold/M=(thresholdmethod)/T=(thresh)/Q/R=M_ROIMask M_Image2Gray
			else
				ImageThreshold/I/M=(thresholdmethod)/T=(thresh)/Q/R=M_ROIMask M_Image2Gray
			endif
			threshold = thresh
			if (thresholdmethod > 0)
				if ((V_threshold < 255) && (V_threshold > 0)) 
					threshold=V_threshold
				endif
			endif 
			ImageAnalyzeParticles /W/Q/M=3/A=(minarea)/R=M_ROIMask/F stats, root:$(dfStr):M_ImageThresh
			PA_boundaryToFront(winStr,"W_BoundaryY","W_BoundaryX") //AppendToGraph/T root:$(dfStr):W_BoundaryY vs root:$(dfStr):W_BoundaryX
			// calculate and print total area particles within ROI
			variable areaParticles=sum(W_ImageObjArea)
			variable errorAreaParticles=sum(W_ImageObjPerimeter)
			//debug
			// print areaParticles,errorAreaParticles,areaTotROIMask
			String textBoxMessage="Object: "+objtypeStr+";\r"+"Threshold = "+num2Str(threshold)+"; Minimum Area = "+num2Str(minarea)+";\r"+"Total area = "+num2Str(areaParticles/areaTotROIMask*100)+"  "+num2Str(errorAreaParticles/areaTotROIMask*50)+" %"
			TextBox/C/N=areatext/A=LB "\\F'Arial'\\Z10"+textBoxMessage
			print ReplaceString("\r", textBoxMessage, " ")
		else
			print "please define ROI using ROI tools"
		endif
	endif
end

Function PA_imageSeries()
	// set datafolder
	String dfStr=SIS_getDataFolderName() // where image is stored
	SetDataFolder root:$(dfStr)
	String stackStr=SIS_getImageStackName() // image name
	String winStr=SIS_getWinName() // nome della finestra
	// global variables
	NVAR layer = root:$(dfStr):layer
	SVAR selectedwaveStr=root:$(stackStr):selectedwaveStr
	wave wv=$selectedwaveStr
	NVAR valdis = root:SIS:valdis
	NVAR threshold = root:SIS:threshold	
	NVAR minimumarea = root:SIS:minimumarea
	NVAR thresholdmethod = root:SIS:thresholdmethod	
	NVAR objecttype = root:SIS:objecttype
	NVAR particlemode = root:SIS:particlemode	
	SetDataFolder root:SIS
	if (!NVAR_Exists(threshold))	     // No such global numeric variable?
		variable/G threshold = 128    // Create and initialize it
	endif
	if (!NVAR_Exists(minimumarea))	// No such global numeric variable?
		variable/G minimumarea = 6	// Create and initialize it
	endif
	if (!NVAR_Exists(thresholdmethod))	 // No such global numeric variable?
		variable/G thresholdmethod = 1	// Create and initialize it
	endif
	if (!NVAR_Exists(particlemode))	 // No such global numeric variable?
		variable/G particlemode = 1	// Create and initialize it
	endif
	if (!NVAR_Exists(objecttype))	     // No such global numeric variable?
		variable/G objecttype = 1	// Create and initialize it
	endif
	//input
	SetDataFolder root:$(dfStr)
	variable thresh=threshold
	variable minarea=minimumarea
	variable objtype=objecttype
	variable mode=particlemode
	variable thm=thresholdmethod+1
	
	variable timeflag=0
	String unitsStr
	variable nlayers = dimSize($stackStr,2)
	// if nlayer == 1 call singleimage
	if (nlayers < 2)
		PA_singleImage()
	endif
	//  input
	String objtypeStr="dark regions"
	Prompt objtype,  "object type", popup "dark regions; bright regions;"
	Prompt mode, "threshold mode", popup "user level (0-255);halfway within ROI; V_avg of ROI; halfway within histogram; relative to histogram maximum;"
	Prompt thresh, "threshold"
	Prompt thm, "threshold method:" popup "V_avg in ROI;iterative;histogram;adaptive thresholding;entropy corrected fuzzy thresholding;fuzzy thresholding 2;"
	Prompt minarea, "minimum area"
	variable from=layer
	Prompt from, "from layer"
	variable to=nlayers-1
	Prompt to, "to layer"
	variable makeMovie=1
	Prompt makeMovie,  "make movie", popup "no; yes;"
	variable fps=5
	Prompt fps, "movie speed (frame/s): "
	doPrompt  "input particle analysis", objtype, mode, thresh, thm, minArea, from, to, makeMovie, fps
	if (V_flag==0)
		
		threshold=thresh
		minimumarea=minarea
		objecttype=objtype
		particlemode=mode
		thresholdmethod=thm-1
				
		if (exists("M_ROIMask")==1) // the ROI wave exists otherwise quit
			if (makeMovie==2) // ask to save movie
				NewMovie /F=(fps)/L/O/Z/I as stackStr
				// define units
				if (stringmatch(selectedwaveStr,"pyro*")==1)
					unitsStr=" C"
				endif
				if (stringmatch(selectedwaveStr,"temp*")==1)
					unitsStr=" C"
				endif
				if (stringmatch(selectedwaveStr,"PMCH*")==1)
					unitsStr=" mbar"
				endif
				if (stringmatch(selectedwaveStr,"time*")==1)
					unitsStr=" s"
					timeflag=1
				endif
			endif
			// initialize waves
			String areaStr=dfStr+"_AR"
			String perimeterStr=dfStr+"_PE"
			String areaerrorStr=dfStr+"_ARE"
			make/n=(nlayers)/O  $areaStr=NaN,   $areaerrorStr=NaN,  $perimeterStr=NaN
			wave aw=$areaStr
			wave aew=$areaerrorStr
			wave pw=$perimeterStr
			// initialize other variables
			if (objtype ==2)
				objtypeStr="bright regions"
			endif
			// calc ROI area
			waveStats/Q M_ROIMask 
			variable areaTotROIMask=V_npnts-V_sum
			// calc threshold for the selected layer
			ImageTransform/P=(layer)/PTYP=0 getPlane $stackStr // puts layer into M_ImagePlane
			ImageTransform convert2gray M_ImagePlane // creates binary image and store result in M_Image2grey
			// variables
			variable midPos,minThres,minVal,maxThres,maxVal
			variable hmax=NaN
			if (mode > 1)
				ImageStats/R=M_ROIMask M_Image2Gray
				if (mode == 2)
					thresh = (V_max+V_min)/2
				endif
				if (mode == 3)
					thresh = V_rms
				endif
				if (mode == 4)
					midPos=(V_max+V_min)/2
					ImageHistogram/R=M_ROIMask M_Image2Gray
					Smooth 5, W_ImageHist
					Wavestats/R=(0,midpos)/Q W_ImageHist
					minThres=V_maxloc
					minVal=V_max
					//print minthres
					Wavestats/R=(midpos,255)/Q W_ImageHist
					maxThres=V_maxloc
					maxVal=V_max
					//thresh = 0.5*(minThres+maxThres)
					thresh = 0.5*(PA_histogramThreshold(W_ImageHist,0.05)+PA_histogramThreshold(W_ImageHist,0.95))
				endif
				if (mode == 5)
					ImageHistogram/R=M_ROIMask M_Image2Gray
					thresh = 0.5*(PA_histogramThreshold(W_ImageHist,0.05)+PA_histogramThreshold(W_ImageHist,0.95))
					wavestats/Q W_ImageHist
					hmax=V_maxloc
				endif
			endif
			// loop
			variable i=from
			variable itot=abs(from-to)
			variable thresh_i
			variable j=0
			String textBoxMessage=""
			variable unitstep= 1 
			if (to<from)
				unitstep=-1
			endif
			do
				// sho layer
				modifyImage $(stackStr) plane=(i)
				valdis=wv[i]
				ValDisplay vd,value=#num2Str(valdis)
				// layer operations
				ImageTransform/P=(i)/PTYP=0 getPlane $stackStr // get layer
				ImageTransform convert2gray M_ImagePlane
				// 
				if (mode == 4)
					ImageHistogram/R=M_ROIMask M_Image2Gray
					WaveStats/Q W_ImageHist
					Smooth 5, W_ImageHist
					thresh = 0.48*(PA_histogramThreshold(W_ImageHist,0.02)+PA_histogramThreshold(W_ImageHist,0.98))
				endif
				// threshold
				if (mode == 5)
					ImageHistogram/R=M_ROIMask M_Image2Gray
					WaveStats/Q W_ImageHist
					Smooth 5, W_ImageHist
					thresh_i = thresh*V_maxloc/hmax
				else
					thresh_i=thresh
				endif
				// calculate threshold image for bright or dark particles
				if (objtype==1)
					ImageThreshold/M=(thresholdmethod)/T=(thresh_i)/Q/R=M_ROIMask M_Image2Gray
				else
					ImageThreshold/I/M=(thresholdmethod)/T=(thresh_i)/Q/R=M_ROIMask M_Image2Gray
				endif 
				ImageAnalyzeParticles /W/Q/M=3/A=(minarea)/R=M_ROIMask/F stats, root:$(dfStr):M_ImageThresh
				// update if i==from
				if (i==from)
					PA_boundaryToFront(winStr,"W_BoundaryY","W_BoundaryX") 
				endif
				// calculate and print total area particles within ROI
				aw[i]=sum(W_ImageObjArea)/areaTotROIMask*100
				aew[i]=sum(W_ImageObjPerimeter)/areaTotROIMask*50
				pw[i]=sum(W_ImageObjPerimeter)/areaTotROIMask*100
				// print texbox on stack 
				if (makeMovie==1)
					textBoxMessage="i = "+num2Str(i)+"; Object: "+objtypeStr+";\r"+"Threshold = "+num2Str(thresh)+"; Minimum Area = "+num2Str(minArea)+";\r"+"Total area = "+num2Str(aw[i])+"  "+num2Str(pw[i])+" %"
					TextBox/C/N=areatext/A=LB "\\F'Arial'\\Z10"+textBoxMessage
					print ReplaceString("\r", textBoxMessage, " ")
				else
					if (timeflag==1)
						sprintf textbox2Str "%*.*f" 4, 2, wv[i]/1000
					else
						sprintf textboxMessage "%*.*f" 4, 2, wv[i]
					endif
					TextBox/C/N=areatext/A=LB textboxMessage+unitsStr
				endif
				// update
				doUpdate
				// movie
				if (makeMovie==2) //  save movie frame
					AddMovieFrame
				endif
				// loop
				i+=unitstep
				j+=1
			//while ((i<=abs(from-to)) && (i>-1))
			while(j<=itot)
			if (makeMovie==2) // close movie
				closeMovie
			endif
			// restore layer
			modifyImage $(stackStr) plane=(from)
			valdis=wv[from]
			ValDisplay vd,value=#num2Str(valdis)
			removeFromGraph W_BoundaryY
			TextBox/K/N=areatext
			doUpdate
			// display results if ...
			variable axis=3
			Prompt axis, "x axis", popup "image number;time;temperature (TC);temperature (PY);other;"
			doPrompt "axes label" axis
			if (V_flag==0)	
				String xStr
				String graphStr="PA"+dfStr
				String paxStr="PA"+dfStr+"_P"
				// image number
				if (axis == 1)
					Prompt xStr, "enter wave",popup WaveList("*NUM*",";","")
					doPrompt "bottom axis input wave" xStr
					if (V_flag==0)	
						duplicate/o $xStr $paxStr
						SIS_xywaveToLeftAxis(graphStr,areaStr,paxStr)
						Label bottom "\\F'Arial'\\Z16Image number"
					endif
				endif
				// time
				if (axis == 2)
					Prompt xStr, "enter wave",popup WaveList("ti*",";","")
					doPrompt "bottom axis input wave" xStr
					if (V_flag==0)	
						duplicate/o $xStr $paxStr
						wave paxw=$paxStr
						paxw*=1000 
						SIS_xywaveToLeftAxis(graphStr,areaStr,paxStr)
						Label bottom "\\F'Arial'\\Z16Time (s)"
					endif
				endif
				// temperature (TC)
				if (axis == 3)
					Prompt xStr, "enter wave",popup WaveList("te*",";","")
					doPrompt "bottom axis input wave" xStr
					if (V_flag==0)	
						duplicate/o $xStr $paxStr
						SIS_xywaveToLeftAxis(graphStr,areaStr,paxStr)
						Label bottom "\\F'Arial'\\Z16Temperature (C)"
					endif
				endif
				// temperature (Pyrometer)
				if (axis == 4)
					Prompt xStr, "enter wave",popup WaveList("py*",";","")
					doPrompt "bottom axis input wave" xStr
					if (V_flag==0)	
						duplicate/o $xStr $paxStr
						SIS_xywaveToLeftAxis(graphStr,areaStr,paxStr)
						Label bottom "\\F'Arial'\\Z16Temperature (C)"
					endif
				endif				
				// other
				if (axis == 5)
					Prompt xStr, "enter wave",popup WaveList("*",";","")
					doPrompt "bottom axis input wave" xStr
					if (V_flag==0)	
						duplicate/o $xStr $paxStr
						SIS_xywaveToLeftAxis(graphStr,areaStr,paxStr)
						Label bottom "\\F'Arial'\\Z16Other"
					endif
				endif
				ModifyGraph fSize=12
				Label left "\\F'Arial'\\Z16Area fraction (%)"
				ModifyGraph mode=4,marker=8;DelayUpdate
				ErrorBars $areaStr Y,wave=($areaerrorStr,$areaerrorStr)
			endif
		else
			print "please define ROI using ROI tools"
		endif
	endif
end

Function PA_histogramThreshold(hw,thresh)
	wave hw
	variable thresh
	variable s=0,i=0
	variable tot= sum(hw)
	do
		s += hw[i]
		i+=1
	while( (s/tot) < thresh )
	return i
end

Function PA_histogramThresholdUp(hw,thresh)
	wave hw
	variable thresh
	variable s=0,i=0
	variable tot= sum(hw)
	do
		s += hw[i]
		i+=1
	while( (s/tot) < thresh )
	return i
end

Function PA_boundaryToFront(graphNameStr,waveNameStr,wavexNameStr)
	String graphNameStr
	String waveNameStr
	String wavexNameStr
	graphNameStr= SIS_removeQuotes(graphNameStr)
	Dowindow $graphNameStr
	if (V_flag==0)
		Display
		DoWindow/C $graphNameStr
		appendToGraph/T $waveNameStr vs $wavexNameStr
		ModifyGraph width=240,height={Aspect,1}
		ModifyGraph mirror=1
	else
		DoWindow/F $graphNameStr
		String empty=WaveList(waveNameStr, ";", "WIN:"+graphNameStr)
		if (strlen(empty)==0)
			appendToGraph/T $waveNameStr vs $wavexNameStr
		endif
	endif
end

Function PA_DarkIslandSize()

	// datafolder
	String dfStr=SIS_getDataFolderName()
	String winStr=SIS_getWinName() // nome della finestra
	String imageStr=SIS_getImageStackName()
	SetDataFolder root:$(dfStr)

	// global variables
	NVAR v_radius = root:SIS:v_radius
	NVAR threshold = root:SIS:threshold	
	NVAR minimumarea = root:SIS:minimumarea
	NVAR thresholdmethod = root:SIS:thresholdmethod	
	NVAR fieldofview = root:SIS:fieldofview
	NVAR ccdbinning = root:SIS:ccdbinning
		
	SetDataFolder root:SIS
	if (!NVAR_Exists(threshold))	     // No such global numeric variable?
		variable/G threshold = 128	// Create and initialize it
	endif
	if (!NVAR_Exists(minimumarea))	// No such global numeric variable?
		variable/G minimumarea = 6	// Create and initialize it
	endif
	if (!NVAR_Exists(v_radius))	// No such global numeric variable?
		variable/G v_radius = 6	// Create and initialize it
	endif
	if (!NVAR_Exists(thresholdmethod))	     // No such global numeric variable?
		variable/G thresholdmethod = 1	// Create and initialize it
	endif
	if (!NVAR_Exists(fieldofview))	     // No such global numeric variable?
		variable/G fieldofview = 2	// Create and initialize it
	endif
	if (!NVAR_Exists(ccdbinning))	     // No such global numeric variable?
		variable/G ccdbinning = 2	// Create and initialize it
	endif

	//input
	SetDataFolder root:$(dfStr)	
	Variable radius = v_radius
	Variable minarea = minimumarea, th = threshold, thm=thresholdmethod+1
	variable cbin = ccdbinning
	variable fov = fieldofview
	
	Prompt minarea, "minimum area:"
	Prompt th, "threshold level:"
	Prompt radius, "radius of fit:"
	Prompt thm, "threshold method:" popup "threshold in ROI;iterative;histogram;adaptive thresholding;entropy corrected fuzzy thresholding;fuzzy thresholding 2;"
	Prompt cbin, "camera binning", popup "1x1;2x2;4x4;8x8"
	Prompt fov,"field of view (um)"
	doPrompt  "input particle analysis:", minArea, radius, th, thm, cbin, fov 
	
	// storing values for next iteration
	threshold = th
	minimumarea = minarea
	v_radius = radius
	thresholdmethod =thm-1
	ccdbinning=cbin
	fieldofview=fov
	variable detectordiameter_px = 870
	variable scaling = 2^(cbin-1)
	variable px2nm = 1000*fov/(detectordiameter_px/scaling)
	
	// if ok
	if(V_flag==0) // pressed ok
		//first iteration of particle analysis
		if (exists("M_ROIMask")==1) // the ROI wave exists otherwise quit
			wave M_ROIMask, M_Image2Gray	
			ImageTransform convert2gray $imageStr
			ImageStats/R=M_ROIMask M_Image2Gray
			ImageThreshold/M=0/T=(threshold)/Q/R=M_ROIMask M_Image2Gray	
			ImageAnalyzeParticles /W/Q/M=3/A=(minarea)/R=M_ROIMask/F stats, root:$(dfStr):M_ImageThresh
			duplicate/o W_SpotX tmpSpotX
			duplicate/o W_SpotY tmpSpotY
			PA_boundaryToFront(winStr,"W_BoundaryY","W_BoundaryX")	
			//
			wave img = $imageStr
			duplicate/o img tmproi
			Redimension/B/U tmproi
			// results
			variable dim = dimsize(tmpSpotX,0), i
			make/N=(dim,7)/O fit_results=NaN
			// fit
			make/O/N=7 W_coef
			make/O/N=(4)/T w_cnstr
			w_cnstr[0] = "K3 > 0" // width_x has to be positive
			w_cnstr[1] = "K5 > 0" // width_y has to be positive
			w_cnstr[2] = "K0 > 0" // image is positive
	       	w_cnstr[3] = "K1 < 0" // dark spots
			wave W_ImageObjArea,W_BoundaryX, W_BoundaryY
			make/O/N=(dim) areaFIT_px,areaPA_px
			make/O/N=(dim) areaFIT_nm,areaPA_nm
		      make/O/N=2 boundaryX,boundaryY
			variable x1, y1, x2, y2 
			// cicle
			for(i = 0; i < dim; i += 1)
				//define fit interval
				x1 = tmpSpotX[i] - radius
				y1 = tmpSpotY[i] - radius
				x2 = tmpSpotX[i] + radius
				y2 = tmpSpotY[i] + radius		
				// roi for particle analysis
				tmproi=1
				tmproi[x1,x2][y1,y2]=0
				// guess parameters for fit
				Imagestats/R=tmproi/Q img
				W_coef[0]=V_max
				W_coef[1]=(V_min-V_max)
				W_coef[2]=tmpSpotX[i]
				W_coef[3]=radius/4
				W_coef[4]=tmpSpotY[i]
				W_coef[5]=radius/4
				W_coef[6]=0
				CurveFit/N/NTHR=0/Q/G  Gauss2D,kwCWave=W_coef img[x1,x2][y1,y2] /D/C=w_cnstr
				// repeat fit after centering interval to gauss
				x1 = W_coef[2] - radius
				y1 = W_coef[4] - radius
				x2 = W_coef[2] + radius
				y2 = W_coef[4] + radius		
				tmproi=1
				tmproi[x1,x2][y1,y2]=0
				CurveFit/N/NTHR=0/Q/G  Gauss2D,kwCWave=W_coef img[x1,x2][y1,y2] /D/C=w_cnstr
				// make a ROI
				tmproi=1
				tmproi[x1,x2][y1,y2]=0
				//re-iterate particle analysis
				ImageTransform convert2gray img 
				ImageStats/R=tmproi M_Image2Gray
				//ImageThreshold/M=(thresholdmethod)/T=(V_avg)/R=tmproi/Q M_Image2Gray
				ImageThreshold/M=(thresholdmethod)/T=(V_min+0.35*(V_max-V_min))/R=tmproi/Q M_Image2Gray	
				ImageAnalyzeParticles /W/Q/M=3/A=(minarea)/R=tmproi/F stats, root:$(dfStr):M_ImageThresh
				areaPA_px[i] = W_ImageObjArea[0]
				// exclude unphysical results
				if ((w_coef[3]>radius) ||  (abs(w_coef[3])<0.5) ||  (w_coef[5]>radius) || (abs(w_coef[5])<0.5) || (abs(W_coef[6])>1) )
					W_coef=NaN
					areaPA_px[i]=NaN
					W_BoundaryX=NaN
					W_BoundaryY=NaN
				endif
				//??? round(fit_results[p][3]*fit_results[p][5]*pi/2)
				// xwidth = sqrt(2*sigma^2) = sqrt(2) *sigma --> sigma = xwidth/sqrt(2)
				// FWHM = 2.355 * sigma --> FWHM = 2.355 * xwidth / sqrt(2)				
				areaFIT_px[i] = pi * W_coef[3]*(2.355/sqrt(2)) * W_coef[5]*(2.355/sqrt(2)) /4
				if (numpnts(W_ImageObjArea)>1)
					areaPA_px[i]=NaN
					areaFIT_px[i]=NaN
					W_BoundaryX=NaN
					W_BoundaryY=NaN
				endif
				if (i==0)
					SIS_imageToFront("Thresh","M_ImageThresh") 
					duplicate/o W_BoundaryX boundaryX
					duplicate/o W_BoundaryY boundaryY
				endif
				PA_boundaryToFront(winStr,"W_BoundaryY","W_BoundaryX")
				Concatenate/NP {W_BoundaryX}, boundaryX
				Concatenate/NP {W_BoundaryY}, boundaryY
				imageTransform/G=(i)/D=w_coef putrow fit_results
				doUpdate

			endfor
			// show threshold
			duplicate/O boundaryX W_BoundaryX
			duplicate/O boundaryY W_BoundaryY  
			PA_boundaryToFront(winStr,"W_BoundaryY","W_BoundaryX")
			// all other data
			areaFIT_nm = areaFIT_px*(px2nm^2)
			areaPA_nm = areaPA_px*(px2nm^2)
			// close threshold window
			dowindow/K Thresh
			// sho table
			string  str_graph_name = "TPA" + imageStr //TPA: Table Particle analysis
			doWindow/K area_table
			edit/N=area_table/K=1 areaFIT_px,  areaPA_px, areaFIT_nm, areaPA_nm, W_SpotX, W_SpotY
			// sho histograms
			PA_makeHistorgram(7, areaPA_nm, "HPA",imageStr)
			PA_makeHistorgram(7, areaFIT_nm, "HFIT",imageStr)
		else
			print "please define ROI using ROI tools"
		endif
	endif
End

// examples
//PA_makeHistorgram(7, areaFIT_nm, "HFIT", "2014_01_30_073_AVG")
//PA_makeHistorgram(7, areaPA_nm, "HPA", "2014_01_30_073_AVG")
function PA_makeHistorgram(bn,dataw,histStr,imageStr)
			//make Histogram 
			variable bn
			wave dataw
			string histStr
			string imageStr
			string whistStr=histStr+imageStr
			wavestats/Q dataw	
			Make/N=(bn)/O $whistStr
			Histogram/B=1 dataw, $whistStr
			String histgraphname = "W" + whistStr 
			String lbLeft =  "\\Z16Frequency"
			String lbBottom = "\\Z16Area (nm\\S2\\M\\Z16)"
			variable mn = 0, mx = V_max + V_max*0.1 //min and max of the graph
			SIS_waveToFront(histgraphname,whistStr)
			ModifyGraph width=200,height={Aspect,1}; ModifyGraph mirror=2
			ModifyGraph lblMargin(bottom)=5; ModifyGraph lblMargin(left)=5
			Label bottom lbBottom, Label left lbLeft
			ModifyGraph mode=5,lsize=1.2,hbFill=5,useNegPat=1,hBarNegFill=5,toMode=1;	ModifyGraph rgb=(0,0,65280)
			SetAxis bottom mn,mx
			Wavestats/Q dataw
			String tmpStr =  "average area = "+num2Str(V_avg)+" nm\S2 \r\Maverage diameter = "+num2Str(2*sqrt(V_avg/Pi))+" nm \r\Mvariance = "+num2Str(2*sqrt(V_sdev/Pi))+" nm"
			TextBox/C/N=text1/A=LB tmpStr
			String avgStr="AVG"+histStr+imageStr
			String diaStr="DIA"+histStr+imageStr
			String varStr="VAR"+histStr+imageStr
			make/N=1/O $avgStr,$diaStr,$varStr
			wave w1=$avgStr
			wave w2=$diaStr
			wave w3=$varStr
			w1[0]=V_avg
			w2[0]=(2*sqrt(V_avg/Pi))
			w3[0]=(2*sqrt(V_sdev/Pi)) 
			String tableStr="TAB"+histStr
			SIS_tableToFront(tableStr,avgStr)
			SIS_tableToFront(tableStr,diaStr)
			SIS_tableToFront(tableStr,varStr)
			return V_avg
end


